<?php

/*
 * NewsPlugin.class.php - a News-Feed portal plugin
 *
 * Copyright (C) 2007 - Andre Klassen <aklassen@uos.de>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 */


/**
 * A Portal Plugin for displaying from RSS-Feeds a defined number of entries.
 *
 * @package     examples
 * @subpackage  portal
 *
 * @author    aklassen
 * @copyright (c) Authors
 * @version   $Id$
 */

define('MAGPIE_CACHE_ON', false);
define('MAGPIE_OUTPUT_ENCODING', 'ISO-8859-1');
	
class NewsPlugin extends AbstractStudIPPortalPlugin {




  function NewsPlugin() {

    parent::AbstractStudIPPortalPlugin();

    $this->setPluginiconname("img/plugin.png");

    # navigation
    $navigation =& new PluginNavigation();
    $navigation->setDisplayname(_("Neuigkeiten"));
    $this->setNavigation($navigation);
  }


  function initialize() {
  }


  function getPluginname() {
    return _("NEWS-Portal-Plugin");
  }


  function actionShow() {

	
  }


  function actionShowAdministrationPage() {
	
	require_once ("lib/classes/Table.class.php");
	require_once ("lib/classes/ZebraTable.class.php");
	
	 $max_entry = $GLOBALS["_POST"]["max"];
	$title = $GLOBALS["_POST"]["header"];
	$subtitle = $GLOBALS["_POST"]["subheader"];
	$feed_url = $GLOBALS["_POST"]["link"];
	$position = $GLOBALS["_POST"]["position"];




		$id= md5($feed_url);
		$db = new DB_Seminar();
		$db->query("SELECT * FROM news_plugin WHERE id = '$id'");



	if($db->next_record()){
		echo "Dieser RSS Feed existiert bereits!";

	}
	$db->query("SELECT * FROM news_plugin WHERE position = '$position'");
	if($db->next_record()){
		echo "Diese Positon wurde bereits vergeben!";

	}
	else
	{	


		if(!($db->next_record()))
		{
			if(!($feed_url==null))
			{
			$db->query("INSERT INTO news_plugin( id,title,subtitle,feed_url,position,max_entry ) VALUES
						('$id','$title','$subtitle','$feed_url','$position','$max_entry')");
			echo "neuer eintrag ist angelegt worden!<br>";
			echo $db;
		    }
		    else if($db->f("position") == $position)
		    {
			 if($position!=null)
			 echo "Die Postion ist schon belegt!";
		    }

	}
   }



	
	
	
	$db = new DB_Seminar();
	$db->query("SELECT * FROM news_plugin ORDER BY position DESC LIMIT 1");
	$db->next_record();
	$position = $db->f("position");
	$position++;
	$max = 5;
	// an ADMIN Menu for setting the RSS Feeds
	
	?>
	

	
	<form action="<?=PluginEngine::getLink($this,array(),"showAdministrationPage")?>" method="post">
	<table width = 100%>
		<tr>
		<td class = topic colspan = 2> Geben Sie hier die entsprechenden Daten fr ein neues News Feld an:</td>
	
		</tr>
		<tr>
			<td width = 20%>Titel</td>
			<td><input type="text" name="header" id="header" value="<?=$header?>"/></td>
		</tr>
		<tr>
			<td>Subtitel</td>
			<td><input type="text" name="subheader" id="subheader" value="<?=$subheader?>"/></td>
		</tr>
		<tr>
			<td>max. Newseintrge</td>
			<td><input type="text" name="max" id="max" value="<?=$max?>" /></td>
		</tr>
		<tr>
			<td>Link zum RSS Feed</td>
			<td><input type="text" name="link" id="link" size="125" value="<?=$link?>" /></td>
		</tr>
		<tr>
			<td>Position</td>
			<td><input type="position" name="position" id="position" value="<?=$position?>" /></td>
		</tr>
		<tr>
			<td></td>
			<td><input type="submit" class='btn' name="ok" id="ok" value= "OK"/></td>
		</tr>
	</table>
	</form>
	
	
	<?


	// Zebratabelle fuer Feeduebersicht
	
	$styles = array("width" => "99%", "align" => "center","spacing" =>"0", "border" => "0", "width" => "100%", "padding" => "5");
	$table = new ContainerTable(array("width" => "100%", "cellspacing" =>"5", "border" => "0", "width" => "100%", "cellpadding" => "5"));
	$tbl2 = new ZebraTable($styles);
	// Titelleiste und Leere Zeile
	echo $table->headerRow("&nbsp;<b>". _("Vorhandene News-Feeds")."</b>");

	// Daten
	echo $tbl2->open();
	
	
		echo $tbl2->openHeaderRow();
		echo $tbl2->cell("Position");
		echo $tbl2->cell("Titel");
		echo $tbl2->cell("Subtitel");
		echo $tbl2->cell("Anzahl der Eintrge");
		echo $tbl2->cell("Feed URL");
		echo $tbl2->cell("Bearbeiten");
		echo $tbl2->cell("Lschen");
		echo $tbl2->closeRow();
	// Eintraege fuer jeden Newsfeedeintrag in der DB
	$db = new DB_Seminar();
	$db->query("SELECT * FROM news_plugin ORDER BY position");
	while($db->next_record())
	{
			echo $tbl2->openRow();
			echo $tbl2->cell($db->f("position"));
			echo $tbl2->cell($db->f("title"));
			echo $tbl2->cell($db->f("subtitle"));
			echo $tbl2->cell($db->f("max_entry"));
			echo $tbl2->cell('<A href="'.$db->f("feed_url").'" target="_blank">'.$db->f("feed_url").'</A>');
			echo $tbl2->cell('<A href="'.PluginEngine::getLink($this,array("subid"=>$db->f("id")),"EditEntry").'"><img src="'. $GLOBALS['ASSETS_URL'].'images/smssave.gif" border="0" alt="Eintrag bearbeiten"></A>');
			echo $tbl2->cell('<A href="'.PluginEngine::getLink($this,array("subid"=>$db->f("id")),"RemoveEntry").'"><img src="'.$GLOBALS['ASSETS_URL'].'images/trash.gif" border="0" alt="Eintrag lschen"></A>');
			echo $tbl2->closeRow();
	}
		echo $tbl2->close();

	// Abschluss fuer unten (Leere Zeile)
	echo $table->closeCell().$table->closeRow();
	echo $table->blankCell($tbl_blank);
	// Alles schliessen
	echo $table->close();

  }


  ## AbstractStudIPPortalPlugin specifics

	function showOverview($authorizedview = TRUE) {
		$db = new DB_Seminar();
		$db->query("SELECT * FROM news_plugin ORDER BY position");
		echo "<br>";
		while($db->next_record())
		{
			 $position = $db->f("position");
			 $title = $db->f("title");
			 $subtitle = $db->f("subtitle");
			 $feed_url = $db->f("feed_url");
			 $id = $db->f("id");	
			 $max_entry =$db->f("max_entry");
   	
?>
<table>
	<td colspan="3" class="steel1">
    <img src="<?= $GLOBALS['ASSETS_URL'] ?>images/indexpfeil.gif" align="left" border="0" valign="middle" alt="">
    <?
    $news = fetch_rss($feed_url);
    ?>
    <table border="0" align="left" cellspacing="0" cellpadding="4">
      <tr valign="top" align="left">
        <td valign="top" colspan="2">
          <font size="4">
            <b><?= _($title) ?></b>
          </font>
          <br />
          <font color="#555555" size="1">
            <?= _($subtitle) ?>
          </font>

        <script type="text/javascript">
           function FensterOeffnen (Adresse) {
             Fenster1 = window.open(Adresse, "Zweitfenster", "width=700,height=400,left=100,top=200,scrollbars=yes");
              Fenster1.focus();
            }
          </script>

        </td>
      </tr>
      <?
	  $i = 0;	
      foreach ($news->items as $key => $val) {
      if ($i <= $max_entry) { ?>
          <tr>
            <td>
              <font size="1">
				<a href="<?=PluginEngine::getLink($this,array("item"=>$key,"title"=>$title,"subid"=>$id),"ShowNews")?>" onClick="FensterOeffnen(this.href); 
					return false;" target = "Zweitfenster">
				  <?= utf8_decode($val["title"])?>
                </a>
              </font>
            </td>
          </tr>
        <?php
        }
        $i++;
	 }
      ?>
      <tr>
        <td></td>
      </tr>
    </table>
  </td>
</tr>
</table>

		
<?
}		

	}


  function hasUnauthorizedView() {
    return TRUE;
  }


  function hasAuthorizedView() {
    return TRUE;
  }

function actionEditEntry() {
   $id = $_REQUEST["subid"];
	$db = new DB_Seminar();
	$db->query("SELECT * FROM news_plugin WHERE id ='$id'");
	$db->next_record();

	?>
		
	  <form action="<?=PluginEngine::getLink($this,array(),"SaveEntry")?>" method="post">
		<table width = 100%>
			<tr>
			<td class = topic colspan = 2> Geben Sie hier die Entsprechenden Daten fr  "<?=$db->f("title")?>"</td>

			</tr>
			<tr>
				<td width = 20%>Titel</td>
				<td><input type="text" name="header" id="header" value="<?=$db->f("title")?>"/></td>
			</tr>
			<tr>
				<td>Subtitel</td>
				<td><input type="text" name="subheader" id="subheader" value="<?=$db->f("subtitle")?>"/></td>
			</tr>
			<tr>
				<td>max. Newseintrge</td>
				<td><input type="text" name="max" id="max" value="<?=$db->f("max_entry")?>" /></td>
			</tr>
			<tr>
				<td>Link zum RSS Feed</td>
				<td><input type="text" name="link" id="link" size="125" value="<?=$db->f("feed_url")?>" /></td>
			</tr>
			<tr>
				<td>Position</td>
				<td><input type="position" name="position" id="position" value="<?=$db->f("position")?>" /></td>
			</tr>
			<tr>
				<td></td>
				<td><input type="submit" class='btn' name="ok" id="ok" value= "OK"/></td>
			</tr>
		</table>  
	</form>
	<?
	
	
  }

function actionRemoveEntry() {
    $id = $_REQUEST["subid"];
	$db = new DB_Seminar();
	$db->query("SELECT * FROM news_plugin WHERE id ='$id'");
	$db->next_record();
	$title = $db->f("title");
	
	echo 'Wollen Sie wirklich den Eintrag "'. $title .'" lschen?';
	
	?>
	<table>
		<tr>
			<td><A href="<?=PluginEngine::getLink($this,array("subid"=>$db->f("id")),"Delete")?>" > <?=makeButton("ja","img")?></A></td>
			<td><A href="<?=PluginEngine::getLink($this,array(),"ShowAdministrationPage")?>" > <?=makeButton("nein","img")?></A></td>
		</tr>
	</table>
		
	<?
	
  }



function actionSaveEntry() {
 	$id = $_REQUEST["subid"];
	$title = $GLOBALS["_POST"]["header"];
	$subtitle = $GLOBALS["_POST"]["subheader"];
	$feed_url = $GLOBALS["_POST"]["link"];
	$position = $GLOBALS["_POST"]["position"];
	$max_entry = $GLOBALS["_POST"]["max"];



		$id= md5($feed_url);
		$db = new DB_Seminar();
		$db->query("SELECT * FROM news_plugin WHERE id = '$id'");
		$db->next_record();


	if(!($feed_url==null))
	{	

			
			$db->query("UPDATE news_plugin SET title = '$title', feed_url = '$feed_url', subtitle = '$subtitle', position = '$position', max_entry = '$max_entry' WHERE id = '$id'");
			echo '<br>Die nderungen am Eintrag "'.$title.'" wurde gespeichert.<br>';
			$this->actionShowAdministrationPage();
    }
	else
	{
		echo "Feed url ist nicht gesetzt, connecten geht nicht klar";
	}
	
	

  
}


function actionDelete() {
	
	$id = $_REQUEST["subid"];
	$db = new DB_Seminar();
	
	// Positon des zu lschenden Eintrags merken
	$db->query("SELECT * FROM news_plugin WHERE id ='$id'");
	$db->next_record();

	$position = $db->f("position");
	$title = $db->f("title");
	
	// Eintrag lschen und hintere Updaten
	$db = new DB_Seminar();
	$db->query("DELETE FROM news_plugin WHERE id = '$id'");
	$db->query("UPDATE news_plugin SET position = position-1 WHERE position > '$position'");

	
	
	
	
	echo '<br><font color=#FF0000>Der Eintrag "'.$title.'" wurde gelscht.</font><br><br>';
	$this->actionShowAdministrationPage();
	
}

function actionShowNews() {
	ob_end_clean();
	?>
	<html>
	<head>
	<title><?PHP echo $title ;?> anzeigen</title>
	<link rel="stylesheet" href="<?=$GLOBALS['ASSETS_URL'] ?>stylesheets/style.css" type="text/css">
	</head>
	<BODY>

	<?php
	
	$id = $_REQUEST['subid'];
	$item = $_REQUEST['item'];
	require_once("vendor/magpierss/rss_fetch.inc");
	 $db = new DB_Seminar();
	 $db->query("SELECT * FROM news_plugin WHERE id ='$id'");
	 $db->next_record();
	 $feed_url = $db->f("feed_url");
	 $news = fetch_rss($feed_url);


	   $title = utf8_decode($news->items[$item]["title"]);
	   $description = utf8_decode($news->items[$item]["description"]);
	?>

	<table align='center' width="80%" cellpadding=5 cellspacing=0>
	<tr>
	  <td class='topic'>
	    <b><?php echo $title;?></b>
	  </td>
	</tr>
	</td>
	    <tr>
	        <td class='blank'><?php echo $description;?></td>
	    </tr>
	</table>
	</body>
	</html>
	<? 
}

}

